// This demonstrates a delayed dtor call for auto classes
// when an exception is thrown. the dtor should be called
// when execution leaves func(), not after main exits.

auto class AutoClass
{
public:
    this()
    {
        printf( "ctor\n" );
        throw new Exception( "" );
    }
    
    ~this()
    {
        printf( "dtor\n" );
    }
}


void func()
{
    auto AutoClass c = new AutoClass();
}


void wrap()
{
    try
    {
        func();
    }
    catch( Exception e )
    {
        printf( "caught\n" );    
    }    
}


void main()
{
    printf( "main begin\n" );
    wrap();
    printf( "main end\n" );
}