// This demonstrates a double dtor call for auto classes
// when an exception is thrown in the class dtor.  The
// dtor should only be called once (when func() exits).

class Except : Exception
{
public:
    this()
    {
        super( "uh oh" );
    }
}

auto class AutoClass
{
public:
    this()
    {
        printf( "ctor\n" );
    }
    
    ~this()
    {
        printf( "dtor\n" );
        throw new Except();
    }
}


void func()
{
    auto AutoClass c = new AutoClass();
}


void main()
{
    try
    {
        func();
    }
    catch( Exception e )
    {
        printf( "caught %.*s\n", e.toString() );    
    }
}