// This will only be testable once 101_1 through 101_3 have
// been fixed.   Correct behavior should be that the class
// dtor will be called when func() exits (because an
// exception has been thrown), and this dtor's throwing of
// an exception should call terminate().  The other option
// would be to attempt some support for multiple exception
// processing.

class Except : Exception
{
public:
    this()
    {
        super( "uh oh" );
    }
}

auto class AutoClass
{
public:
    this()
    {
        printf( "ctor\n" );
    }
    
    ~this()
    {
        printf( "dtor\n" );
        throw new Except();
    }
}


void func()
{
    auto AutoClass c = new AutoClass();
    throw new Except();
}


void main()
{
    try
    {
        func();
    }
    catch( Exception e )
    {
        printf( "caught %.*s\n", e.toString() );    
    }
}